
/* JavaScript content from js/AppCenterHTML.js in folder common */
/*
 *  Licensed Materials - Property of IBM
 *  5725-G92 (C) Copyright IBM Corp. 2011, 2012. All Rights Reserved.
 *  US Government Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */
    require([
             "dojo/_base/kernel",
    		 "dojo/_base/lang",
    	     "dojo/_base/window",
    	     "dojo/_base/fx",
    	     "dojo/_base/html",
    	     "dojo/_base/json",
    	     "dojo/_base/array",
    	     "dijit/registry",
    	     "dojo/ready",
    		 "dojo/dom",
    		 "dojo/dom-style",
    		 "dojo/dom-class",
    		 "dojo/_base/connect",
    		 "dojox/mobile",		
    		 "dojox/mobile/parser",
    		 "dojox/mobile/i18n",
             "com/ibm/mobile/appcenter/InstallerHTML",
             "com/ibm/mobile/appcenter/Settings",
             "com/ibm/mobile/appcenter/Connection",
    		 "dojox/uuid/generateRandomUuid",	
    		 "dojox/mobile/View",
    		 "dojox/mobile/FixedSplitter",
             "dojox/mobile/Container",     		 
    		 "dojox/mobile/Heading",
    		 "dojox/mobile/ToolBarButton",
    		 "dojox/mobile/TabBar",
    		 "dojox/mobile/TabBarButton",
    		 "dojox/mobile/ScrollableView",
    		 "dojox/mobile/EdgeToEdgeCategory",
    		 "dojox/mobile/EdgeToEdgeList",
    		 "dojox/mobile/ListItem",
    		 "dojox/mobile/RoundRectList",
    		 "dojox/mobile/RoundRectCategory",
    		 "dojox/mobile/RoundRect",
    		 "dojox/mobile/Button",
    		 "dojox/mobile/RoundRectList",
    		 "dojox/mobile/TextArea",
    		 "dojox/form/Rating",
    		 "dojox/mobile/TextBox",
    		 "dojox/mobile/CheckBox",
    		 "dojox/mobile/ProgressIndicator",
    		 "dojo/domReady!"], 
    function(dojo, lang, win, fx, html, json, arr, registry, ready, dom, domStyle, domClass, connect, mobile, parser, i18n,installerNative, installerSettings, installerConnections) {
	
        var OS_HTML5 			    = 'HTML5';
        var APP_MENU_VIEW_ID        = 'appMenuView';
        var TEXT_DETAILS_VIEW_ID    = 'textDetailsView';
        var APP_INFO_VIEW_ID        = 'appInfoView';
        var MY_MOBILE_VIEW_ID       = 'myMobileView';
        var APP_CATALOG_VIEW_ID     = 'catalogView';
        var SWITCH_VIEW_ID		    = 'versionSwitcherView';
        var IN_PROGRESS_VIEW_ID     = 'inProgressView';
        var SETTINGS_VIEW_ID        = 'settingsView';
        var NO_APP_SELECTED_VIEW_ID = 'noAppContentView';
        var FEEDBACK_VIEW_ID        = 'feedbackDetailsView';
        
        
        var APP_INFO_HEADING_ID     = 'appInfoHeadingWidget';
        var TXT_INFO_HEADING_ID     = 'textDetailsHeadingWidget';
        var FEEDBACK_HEADER_ID 		= 'feedbackDetailsHeadingWidget';
        var SWITCH_VERSION_HEADER_ID = 'versionSwitcherHeadingWidget';
        
        var USER_AREA_ID 			= 'user-area';
        var MY_MOBILE_HEADER_ID     = 'myMobileViewHeader';
        var CATALOG_HEADER_ID       = 'catalogViewHeader';
        var IN_PROGRESS_HEADER_ID   = 'inProgressViewHeader';
        var SETTINGS_HEADER_ID      = 'settingsViewHeader';
        
        var SETTINGS_TAB_ID         = 'settingsTab';
        var MY_MOBILE_TAB_ID        = 'myMobileTab';
        var CATALOG_TAB_ID          = 'catalogTab';
        var INPROGRESS_TAB_ID       = 'inProgressTab';
                        
        var APP_INFO_DESCR_NAV_ID   = 'appInfoDescriptionNav';
        var APP_INFO_PKG_NAV_ID     = 'appInfoPackageNav';
        var APP_INFO_HEAD_TEXT_ID   = 'appInfoHeadingText';
        var APP_INFO_DESCRIPTION_ID = 'appInfoDescription';
        var APP_INFO_MANDATORY_ID   = 'appInfoMandatory';
        var APP_INFO_VERSION_ID     = 'appInfoVersion';                    
        var APP_INFO_PKG_ID         = 'appInfoPackage';
        var APP_INFO_RATING_ID      = 'appInfoRating';
        var APP_INFO_LIST_ID        = 'appInfoList';
        
        var PROG_INFO_STATUS_ID     = 'progressInfoStatus';
        var STATUS_LIST_ID          = 'statusList'; 
        var APP_INSTALL_LIST_ID     = 'appInstallList';         
        var APP_REMOVE_LIST_ID      = 'appRemoveList';
        var APP_CANCEL_LIST_ID      = 'appCancelList';
                
        var TEXT_DETAILS_CAT_ID     = 'textDetailsCategoryText';
        var TEXT_DETAILS_TEXT_ID    = 'textDetailsText';
        var TEXT_DETAILS_HEAD_ID    = 'textDetailsHeadingText';
                
        var INSTALL_BUTTON_ID       = 'installButton';
        var REMOVE_BUTTON_ID        = 'removeButton';
        var NOT_INSTALLED_BUTTON_ID = 'reportNotInstalledButton';
        var CANCEL_BUTTON_ID        = 'cancelButton';
        var SWITCH_BUTTON_ID        = 'switchButton';
        var INSTALL_PROFILE_BUTTON_ID   = 'installProfileButton';
        var NOT_IN_PROGRESS_BUTTON_ID   = 'reportNotInProgressButton';
        
        var OFFLINE_UPDATE_LIST_ID  = 'offlineUpdateListItem';
        var OFFLINE_CATALOG_LIST_ID = 'offlineCatalogListItem';
        var OFFLINE_UPDATE_TEXT_ID  = 'offlineUpdateListItemText';
        var OFFLINE_CATALOG_TEXT_ID = 'offlineCatalogListItemText';
        var OFFLINE_ICON_ID         = 'offlineIcon';
        var LEFT_OFFLINE_ICON_ID         = 'leftOfflineIcon';
        
        var OFFLINE_STSTUS_UPDATE_ID    = 'offlineUpdateListItemStatus';
        var OFFLINE_STATUS_CATALOG_ID   = 'offlineCatalogListItemStatus';
        
        var MAIN_APP_SPLITTER_ID    = 'appMenuSplitter';
        var LEFT_SPLITTER_AREA_ID   = 'leftSplitterPane';
        var RIGHT_SPLITTER_AREA_ID  = 'rightSplitterPane';
        var TOP_VERTICAL_SPLITTER_ID= 'verticalSplitter';                        
        var BOTTOM_PANE_ID          = 'bottomSplitterPane';
        
        var TAB_CONTROL_ID          = 'tabBar';
        
        var SWITCH_VER_BUTTON_ID    = 'versionSwitcherSwitchButton';            
        var SWITCH_VER_LIST_ID      = 'versionSwitcherList';
        var SWITCH_VER_BUTTON_LIST_ID = 'versionSwitcherButtonList';
        var SWITCH_VER_TEXT_ID      = 'versionSwitcherInstalledVersionDetailsText';    
        
        var FEEDBACK_SUBMIT_ID      = 'feedbackDetailsSubmitButton';
        var FEEDBACK_STARS_ID       = 'feedbackDetailsRating';        
        var FEEDBACK_TEXT_ID        = 'feedbackDetailsTextArea'; 
            
        var REFRESH_BUTTON_ID       = 'refreshButton';
        var LEFT_REFRESH_BUTTON_ID       = 'leftRefreshButton';
        
                		                
        if(!window.localStorage) {
        	alert('Cannot save application state across reloads!');
        }
        
        var PureMEAP = null;
        var bundle = null;
        var FeedbackInfo = null;

        /**
         * On resize / orientation-change
         */
        
        window.onresize = function () {
    
            if(!PureMEAP) {
                // We are during startup ignore
            }
            else {
                PureMEAP.refreshLayout();
            }
        };
        window.onorientationchange = window.onresize;
        
        /**
         * Called from the native part to set on/off network connectivity
         * 
         * @return none
         */
        //TODO need to handle this in WL 
        function offlineMode(pEnabled) {
        
        	console.log("offlineMode(" + pEnabled +")");
        	
        	PureMEAP.offlineMode(pEnabled);
        }
        
        /**
         * Called from the native part when the back button is captured and the user
         * presses back
         * 
         * @return none
         */
        function sendOnBack() {		
        
        	PureMEAP.moveBack();
        }

        /**
         * Called from the native part to trigger update to the icon list
         * 
         * @return none
         */
        function reloadIcons() {
        
        	console.log("Starting reload icons... " + (new Date));
        	
        	if(PureMEAP) {
        		PureMEAP.reloadIcons();
            }
        	
        	console.log("Ending reload icons... " + (new Date));
        };
        
        /**
         * Called from the native part to trigger update to the lists presented in the view
         * 
         * @return none
         */
        function reload() {
        
        	console.log("Starting reload... " + (new Date));
        	
        	if(PureMEAP) {
        		PureMEAP.reload(false);
            }
        	
        	console.log("Ending reload... " + (new Date));
        };

        /**
         * Called from the native part to trigger update the inprogress view with notification
         * 
         * @return none
         */
        function inProgressNotification(pTaskUid, pMsg) {
        
        	console.log("Starting inProgressNotification for task " + pTaskUid + "with message" + pMsg);
        	
        	if(PureMEAP) {
        		PureMEAP.inProgressNotification(pTaskUid, pMsg);
        	}
        	
        	console.log("Ending inProgressNotification for " + pTaskUid);
        };
        
        /**
         * Called from the native part to trigger update to the lists presented in the view
         * when an installation was successfully canceled.
         * 
         * @return none
         */
        function cancelInProgress(pMsg) {
        
        	console.log("Starting cancelInProgress with message " + pMsg);
        	
        	if(PureMEAP) {
        		PureMEAP.cancelInProgress(pMsg);
        	}
        	
        	console.log("Ending cancelInProgress with message " + pMsg);
        };

        /**
         * Called from the native part when an external application is starting the 
         * installer to send some feedback information
         * 
         * @return none
         */
        function onFeedbackRequest(pAppID,              // Mandatory 
                                   pAppVersion,         // Optional
                                   pStarRating,         // Optional
                                   pFeedbackString) {   // Optional
            // Update this method to change start feedback going...
        	FeedbackInfo = {
        			pkg: pAppID,
        			version: pAppVersion,
        			stars: pStarRating,
        			feedback: pFeedbackString
        	};
        	
        	console.log("Starting onFeedbackRequest with request " + JSON.stringify(FeedbackInfo));
        	
        	if(PureMEAP) {
        		PureMEAP.onFeedbackRequest();
        	}
        	
        	console.log("Ending onFeedbackRequest with request " + JSON.stringify(FeedbackInfo));        	
        }

        ready(function () {
        	
        	console.log("Starting onload... " + (new Date));

        	// load resource bundle for i18n
        	var deflang = location.search.match(/lang=(\w*)/) ? RegExp.$1 : null;
        	bundle = i18n.load("nlsBase", "nls_installer", deflang);
        
        	var installer;
        	
        	var initFunction = function () {
        		console.log("Starting initialize... " + (new Date));
        		installer = new MeapInstaller(bundle);
        		installer.initialize();
                        PureMEAP = installer; 
                        PureMEAP.refreshLayout();
                        console.log("Ending onload... " + (new Date));
        	}; 
        	
        	installerNative.init(bundle,
        						 initFunction, 
        			             reloadIcons, 				// iconUpdateCallback
        			             reload, 					// applicationsUpdateCallback
        			             inProgressNotification,	// inprogressUpdateCallback
        			             cancelInProgress,			// cancelUpdateCallback
        			             onFeedbackRequest);        // feedbackRequestCallback

        		 						 		
        });

        function AppList(pAppListInfo, pPureMeapInstaller) {
        	
        	this.emptyMsgItemID 	= pAppListInfo.emptyMsgItemID; 
        	this.offlineMsgItemID 	= pAppListInfo.offlineMsgItemID;
        	this.restRequestSuffix 	= pAppListInfo.restRequestSuffix;
        	this.viewID 			= pAppListInfo.viewID;
        	this.listItems 			= pAppListInfo.listItems;
        	this.apps 				= pAppListInfo.apps;
        	this.listContainerID 	= pAppListInfo.listContainerID;
        	this.filterInProgress 	= pAppListInfo.filterInProgress;
        	this.storageSaveKey 	= pAppListInfo.storageSaveKey;
        	this.pureMeapInstaller  = pPureMeapInstaller;
        };
        
        AppList.prototype.getApp = function(pPkg, pVersion) {
        
        	var i = this._appIndex(pPkg, pVersion);
        	
        	if(i > -1)
        		return this.apps[i];
        	
        	return null;
        };
        
        AppList.prototype.addApp = function(pApp) {
        
        	var appIdex = this._appIndex (pApp.pkg, pApp.version); 
        
        	if(appIdex == -1) {
        		
        		this.apps.push(pApp);					
        		this._saveIntoLocal();
        		
        		this._addListItem(pApp);
        		this._updateEmptyMessage();
        	}
        };
        
        AppList.prototype.removeApp = function(pApp) {
        
        	var removeIndex = this._appIndex (pApp.pkg, pApp.version); 
        
        	if(removeIndex != -1) {
        		
        		this.apps.splice(removeIndex, 1);					
        		this._saveIntoLocal();
        		
        		this.hideListItem(pApp);
        	}
        };
        
        AppList.prototype.removeAppByTaskUid = function(pTaskUid) {
        
        	var removeApp = this._appByTaskUid (pTaskUid); 
        	if(removeApp) {
        		this.removeApp(removeApp);		
        	}
        	
        	return removeApp;
        };
        
        AppList.prototype.showListItem = function(pApp) {
        	
        	var idex = this._appIndex(pApp.pkg, pApp.version);
        	
        	if(idex > -1) {
        		
        		this._addListItem(pApp);
        		
        		this._updateEmptyMessage();
        	}
        };
        
        AppList.prototype.hideListItem = function(pApp) {
        	
        	var idex = this._listItemIndex(pApp.pkg, pApp.version);
        	
        	if(idex > -1) {
        		var appListItem = this.listItems[idex];
        		
        		this.listItems.splice(idex, 1);
        		
        		appListItem.domNode.parentNode.removeChild(appListItem.domNode);
        		appListItem.destroyRecursive();
        		
        		this._updateEmptyMessage();
        	}
        };
        
        AppList.prototype.loadApplicationsIntoListFromLocal = function() {
        	
        	this._loadFromLocal();
        	this.replaceApps(this.apps);
        };
        
        AppList.prototype.loadApplicationsIntoList = function(pAsynch, pPostLoadFunc) {
        	
        	this._updateEmptyMessage(this.pureMeapInstaller.bundle.loadingMessage);
        
        	var restURL = installerConnections.getApplicationListURL(this.pureMeapInstaller.getServerURL(), 
        	          installerNative.getDeviceId(),
        	          installerNative.getFilter(),
        	          this.restRequestSuffix);
        		
        	console.log("calling |" + restURL + "| " + pAsynch);
        	
        	var _this = this;
        	
        	var errorFunction = function(error, ioargs) {
        		var xhttp = ioargs.xhr;
        		if(error) {
        			console.log("Exception cauth " + error + "on URL|" + restURL);
        		}
        		if(pPostLoadFunc)
    				pPostLoadFunc(true);
        		_this.pureMeapInstaller.offlineMode(true);
        		_this._updateEmptyMessage();
        	};
        	
        	var completeFunction = function(data, ioargs) {
        		var xhttp = ioargs.xhr;
        		console.log("|calling " + restURL + " returned with status|" +  xhttp.status);
        		if (xhttp.status == 200) {
        			var apps = JSON.parse(data);		
        			_this.pureMeapInstaller.offlineMode(false);
        			_this.replaceApps(apps);
        			if(pPostLoadFunc)
        				pPostLoadFunc();
        		} else {
        			errorFunction(null, ioargs);
        		}
        	};
        	
        	var xhrArgs = {
        		    url: restURL,			
        		    user: _this.pureMeapInstaller.getUsername(),
        		    password: _this.pureMeapInstaller.getPassword(),	
        		    load: completeFunction,
        		    error: errorFunction,
        		    sync: !pAsynch,
        		    timeout: 5000,
        		    preventCache: true,
        		    handleAs: "text"
        	};        	
        	
        	installerConnections.xhrGet(xhrArgs);
        };
        
        AppList.prototype.dropAppsBelongingTo = function(pOther) {
        	
        	for(var i = 0 ; i < pOther.apps.length ; i++) 
        		this.removeApp(pOther.apps[i]);
        };
        
        AppList.prototype.getSelectedApp = function() {
        
        	var listItem = this._getSelectedListItem();
        	
        	if(listItem) {
        		return listItem._appInfo;
        	}
        	
        	return null;
        };
        
        AppList.prototype.replaceApps = function(pAppArray) {
        	
        	var selectedApp = this.getSelectedApp();
        	
        	for(var i = 0 ; i < this.listItems.length ; i++) {
        		
        		var appListItem = this.listItems[i];
        		
        		appListItem.domNode.parentNode.removeChild(appListItem.domNode);
        		appListItem.destroyRecursive();
        	}
        
        	this.listItems = Array();
        	
        	this.apps = pAppArray;
        	this._saveIntoLocal();
        	
            if(pAppArray.length > 0) {
                for(var i = 0 ; i < pAppArray.length ; i++) {
                	
                	if(this.filterInProgress && 
                	   (this.pureMeapInstaller.inprogress._appIndex(pAppArray[i].pkg, pAppArray[i].version) != -1 || 
                	    this.pureMeapInstaller.installed._appIndex(pAppArray[i].pkg, pAppArray[i].version) != -1)) 
                		continue;
                	
                	this._addListItem(pAppArray[i]);        	
                }
            }
            
            // If selection changed, update the views
            if(this.listItems.length > 0) {
                var idex = -1;
                if(selectedApp) 
                    idex = this._listItemIndex(selectedApp.pkg, selectedApp.version);
                if(idex < 0) 
                    idex = 0;
            
                if(PureMEAP && PureMEAP.isTablet && 
                   (PureMEAP.updated != this || PureMEAP.installed.apps.length == 0)) {
                    this.listItems[idex].set('selected', true);
            
                    if((PureMEAP.selected.list == this) ||
                       (PureMEAP.selected.list == PureMEAP.installed && PureMEAP.updated == this && PureMEAP.installed.apps.length == 0)) {
            
                        PureMEAP.applicationSelected(this.listItems[idex]._appInfo, this);
                        registry.byId(APP_INFO_VIEW_ID).show(true, false);
                    }            
                }
            }
            else if(PureMEAP) { 
                if(PureMEAP.selected.list == this) {
                    PureMEAP.selected.app = null;
                    if(PureMEAP.isTablet)
                        registry.byId(NO_APP_SELECTED_VIEW_ID).show(true, false);
                    else 
                        registry.byId(this.viewID).show(true, false);            
                }
            }            
            this._updateEmptyMessage();	
        };
        
        AppList.prototype._saveIntoLocal = function() {
        	
        	if(this.storageSaveKey)
        		if(window.localStorage && window.localStorage.setItem)
        			window.localStorage.setItem(this.storageSaveKey, json.toJson(this.apps));
        		else 
        			console.log("local storage is not working for save");   
        };
        
        AppList.prototype._clearApps = function() {        	
        	this.apps = Array();		        
        };
        
        AppList.prototype._loadFromLocal = function() {
        	
        	if(this.storageSaveKey) 
        		if(window.localStorage && window.localStorage.getItem) { 
        			var appArrayJson = window.localStorage.getItem(this.storageSaveKey);
        			if(appArrayJson) 
        				this.apps = json.fromJson(appArrayJson);		
        		}
        		else 
        			console.log("local storage is not working");   
        };
        
        AppList.prototype._updateEmptyMessage = function(msgStatus) {
        	// even if we are offline now the list might be full since we got it before 
        	// we got disconnected
        		
        	var offlineUpdateStatus = dom.byId(OFFLINE_STSTUS_UPDATE_ID);	
        	var offlineCatalogStatus = dom.byId(OFFLINE_STATUS_CATALOG_ID);
        	
        	if(msgStatus) {
        		offlineUpdateStatus.innerText = msgStatus;	
        		domStyle.set(offlineUpdateStatus, 'display', 'block');
        		
        		offlineCatalogStatus.innerText = msgStatus;
        		domStyle.set(offlineCatalogStatus, 'display', 'block');
        	}
        	else {
        		offlineUpdateStatus.innerText = "";	
        		domStyle.set(offlineUpdateStatus, 'display', 'none');
        		
        		offlineCatalogStatus.innerText = "";
        		domStyle.set(offlineCatalogStatus, 'display', 'none');
        	}
        	
        	console.log("Updating empty messages for " + this.viewID + 
        			    " with offline " + this.offlineMsgItemID + 
        			    " and empty " + this.emptyMsgItemID);
        
        	if(this.offlineMsgItemID)
        		domStyle.set(registry.byId(this.offlineMsgItemID).domNode, 'display', 'none');
        	domStyle.set(registry.byId(this.emptyMsgItemID).domNode, 'display', 'none');
        	
        	console.log("Number of list items is " + this.listItems.length + 
        		    	" with offline status " + this.pureMeapInstaller.offline);
        	
        	if(this.listItems.length == 0) {
        		if(this.offlineMsgItemID  && this.pureMeapInstaller.offline) {
        			domStyle.set(registry.byId(this.offlineMsgItemID).domNode, 'display', 'block');
        		}
        		else
        			domStyle.set(registry.byId(this.emptyMsgItemID).domNode, 'display', 'block');
        	}
        };
        
        AppList.prototype._appIndex = function(pPkg, pVersion) {
        
        	for(var i = 0 ; i < this.apps.length ; i++) 
        		if(this._appMatch(this.apps[i], pPkg, pVersion))
        			return i;
        	
        	return -1;
        };
        
        AppList.prototype._appByTaskUid = function(pTaskUid) {
        
        	for(var i = 0 ; i < this.apps.length ; i++) 
        	{
        		if(this.apps[i].task_uid == pTaskUid)
        		{	
        			return this.apps[i];
        		}
        	}
        	return null;
        };
        
        AppList.prototype._listItemIndexForPkg = function(pPkg) {
            
        	for(var i = 0 ; i < this.listItems.length ; i++) 
        		if(this._appMatchForPkg(this.listItems[i]._appInfo, pPkg)) 
        			return i;
        	
        	return -1;
        };
        
        AppList.prototype._appMatchForPkg = function(pApp, pPkg) {
        
        	if(pApp.pkg == pPkg) {        		
        			return true; 
        	}
        	
        	return false;
        };   
        
        AppList.prototype._listItemIndex = function(pPkg, pVersion) {
        
        	for(var i = 0 ; i < this.listItems.length ; i++) 
        		if(this._appMatch(this.listItems[i]._appInfo, pPkg, pVersion)) 
        			return i;
        	
        	return -1;
        };
        
        AppList.prototype._appMatch = function(pApp, pPkg, pVersion) {
        
        	if(pApp.pkg == pPkg) {
        		// TODO: we will have to fix this in the store
        		var dottedVer = ''+ pApp.version + '.0';
        		
        		if(pApp.version == pVersion || pVersion == dottedVer)
        			return true; 
        	}
        	
        	return false;
        };        
        
        AppList.prototype._buildApplicationIconURLPrefix = function(pForApp) {
        
        	for (var urlIdx = 0; urlIdx < pForApp.url.length; urlIdx++) 
        		if (pForApp.url[urlIdx].rel == "icon") 
        			return  "service/icons/" + 
        	          	     pForApp.url[urlIdx].value;
        		
        	return "service/device/" + 
        			  installerNative.getDeviceId() + 
        	          "/install/" +
        	          pForApp.pkg +
        	          "/icon";
        };
        
        AppList.prototype._getApplicationIconPath = function(pForApp) {
        	
        	var url = installerConnections.getApplicationIconURL(this.pureMeapInstaller.getServerURL(), 
        			pForApp,
        			installerNative.getDeviceId());
        	var iconPath = this.pureMeapInstaller.icons[url];
        	if (iconPath) {
        		console.log("loading icon from local " + iconPath);
        		return iconPath;
        	}
        	console.log("requesting to download icon " + url);
        	// make sure we won't ask for the icon again untill it comes back
        	this.pureMeapInstaller.icons[url] = url;
        	// download the icon
        	installerNative.downloadIcon(url);
        
        	return url;
        };
        
        AppList.prototype._getSelectedListItem = function() {
        	
        	if(registry.byId(this.listContainerID).stateful &&
        	   this.listItems.length > 0) {
        		
        		for(var i = 0 ; i < this.listItems.length; i++) 			
        		    if(this.listItems[i].get('selected'))
        				return this.listItems[i];
        	}
        	
        	return null;
        };
        
        AppList.prototype._addListItem = function(pApplication) {
        
        	var newListItem = new dojox.mobile.ListItem({ 
        		icon: this._getApplicationIconPath(pApplication),
        		label: this.pureMeapInstaller.listItemLabel(pApplication.label),
        		moveTo: APP_INFO_VIEW_ID,
        		noArrow: false,
        		selected: false});
        	newListItem._appInfo = pApplication;
        	newListItem._listInfo = this;
        	newListItem.labelNode.innerText = this.pureMeapInstaller.listItemLabel(pApplication.label);
        	
        	this.listItems.push(newListItem);
        	
        	var _this = this;
        	
        	registry.byId(this.listContainerID).addChild(newListItem);
        	newListItem._savedConnect = connect.connect(newListItem, "onClick", function() {
        		_this.pureMeapInstaller.applicationSelected(pApplication, _this);
        	});
        };
                        
                
        AppList.prototype.loadApplicationVersionsIntoList = function(pApplication,pAsynch){
        	
        	this._updateEmptyMessage( this.pureMeapInstaller.bundle.loadAppVersionsMessage);
        
        	var restURL = installerConnections.getApplicationVersionsListURL(this.pureMeapInstaller.getServerURL(), pApplication);
        		
        	console.log("calling |" + restURL + "| " + pAsynch);
        
        	var _this = this;
        	
        	var errorFunction = function(error, ioargs) {
        		if(error) {
        			console.log("Exception cauth " + error);
        		}
        		_this.pureMeapInstaller.offlineMode(true);
        		_this._updateEmptyMessage();
        	};
        	
        	var completeFunction = function(data, ioargs) {
        		var xhttp = ioargs.xhr;
        		console.log("loadApplicationVersionsIntoList retuned with status " + xhttp.status);
        		if (xhttp.status == 200) {	
        			_this.pureMeapInstaller.offlineMode(false);
        	
        			var appInfo = JSON.parse(data);
        			
        			// Check to see if user still has access to this application
        			if (appInfo[0].is_can_list_authorized == false) {
        				// User no longer have access to this application
                        domStyle.set(registry.byId(SWITCH_BUTTON_ID).domNode, 'display', 'none');
                        return;
        			}
        			
        			var appVersions = appInfo[0].versions;
        			
                    // Check to see if we need to display the switch button for versioning
                    if (appVersions.length < 2) {
                        domStyle.set(registry.byId(SWITCH_BUTTON_ID).domNode, 'display', 'none');
                        return;
                    } 
                    else {
                    	var invalid = 0;
                    	// mark the items that are inprogress 
                    	for(var i = 0 ; i < appVersions.length ; i++) {
                    		if (-1 != _this.pureMeapInstaller.inprogress._appIndex(pApplication.pkg, appVersions[i].version)) {
                    			appVersions[i].invalid = true;
                    			invalid ++;
                    		}
                    	}
                    	if ((appVersions.length - invalid) < 2 ) {
                    		domStyle.set(registry.byId(SWITCH_BUTTON_ID).domNode, 'display', 'none');
                            return;
                    	}
                        domStyle.set(registry.byId(SWITCH_BUTTON_ID).domNode, 'display', '');                 
                    }
        			
        			// get list widget to display the version numbers
        			var listwidget = registry.byId(SWITCH_VER_LIST_ID);
        			var childrenwidgets = listwidget.getChildren();
        			
        			//remove all list item
        			for(var i = 0 ; i < childrenwidgets.length ; i++) {
        				var w = childrenwidgets[i];
        				listwidget.removeChild(w);
        				w.destroyRecursive();
        			}
        			
        			// create and add list item corresponding to each version
        			for(var i = 0 ; i < appVersions.length ; i++) {
        				// do not add current installed version into the list of available versions
        				if( appVersions[i].version==pApplication.version || appVersions[i].invalid) continue;
        				
        				var newListItem = new dojox.mobile.ListItem({ 
        					label: appVersions[i].version,					
        					selected: false});
        				newListItem._versionInfo = appVersions[i];
        				listwidget.addChild(newListItem);
        			}
        			
        			return appVersions.length;						
        		} else {
        			errorFunction(null, ioargs);
        		}
        	};
        
        	var xhrArgs = {
        		    url: restURL,			
        		    user: _this.pureMeapInstaller.getUsername(),
        		    password: _this.pureMeapInstaller.getPassword(),	
        		    load: completeFunction,
        		    error: errorFunction,
        		    sync: !pAsynch,
        		    timeout: 5000,
        		    preventCache: true,
        		    handleAs: "text"
        	};
        	
        	installerConnections.xhrGet(xhrArgs);
        };
        
        
        function MeapInstaller(pBundle) {
        	
        	this.bundle = pBundle;
        	this.serverURLKey = "serverURLKey";
        	this.usernameKey = "usernameKey";
        	this.contextRootKey = "contextRootKey";
        		
        	this.offline = true;
            this.isAndroid = true;  
        	this.isDeviceRegisterred = false;
        	
        	this._username = "";
        	this._password = "";
        	this._contextRoot = "";
        	
        	// handle server url
        	this._serverURL = "";
        	if(window.localStorage && window.localStorage.getItem){  
        		this._serverURL = window.localStorage.getItem(this.serverURLKey);
        		this._username = window.localStorage.getItem(this.usernameKey);
        		this._contextRoot = window.localStorage.getItem(this.contextRootKey);
        	}
        	if (this.isAndroid && !this._serverURL) {
        		this._serverURL = "http://localhost:9080/applicationcenter";		
        	}	
        	
        	this.selected = {
        	    app: null,
        	    list: null
        	};
        
            this._os         = this.isAndroid ? "Android" : "iOS";
        	this._width      = installerNative.getWidth();
        	this._height     = installerNative.getHeight();
        
        	this.isLandscape = (this._width > this._height) && (this._width > 500);
            this.isTablet    = false;//Math.min(this._height, this._width) > 500;
        	
        	this._versionCount = 0;
        	this._versionToInstall = null;
        								
        	this.getFilter					= installerNative.getFilter;
        	this.getDeviceID 				= installerNative.getDeviceId;
        	this.installApplication 		= installerNative.installApplication;		
        	this.removeApplication 			= installerNative.removeApplication;
        	this.cancelApplication 			= installerNative.cancelApplication;
        	this.readAppsJsonString 		= installerNative.getInstalledApplications;
        	this.readInProgressJsonString 	= installerNative.getInprogressApplications;		
        	this.readIconsJsonString		= installerNative.getIconsCache;
        	this.downloadIcon 				= installerNative.downloadIcon;
        	this.exitInstaller				= installerNative.exitInstaller;
        	this.launchConfigSettings		= installerNative.launchConfigSettings;
        
        	this.updated = new AppList({
        		emptyMsgItemID: 'nothingToUpdateListItem',
        		offlineMsgItemID: OFFLINE_UPDATE_LIST_ID,
        		restRequestSuffix: 'updates',
        		viewID: MY_MOBILE_VIEW_ID,		
        		listItems: Array(),
        		apps: Array(),
        	    listContainerID: 'updatedList',
        	    filterInProgress: true
        	}, this);
        
        	this.installed = new AppList({
        			emptyMsgItemID: 'nothingInstalledListItem',
        			restRequestSuffix: 'package',
        			viewID: MY_MOBILE_VIEW_ID,
        			listItems: Array(),
        			apps: Array(),
        			storageSaveKey: 'ibm_app_installed_list_key',
        		    listContainerID: 'installedList',
        		    filterInProgress: false
        		}, this);
        	
        	this.catalog = new AppList({
        			emptyMsgItemID: 'nothingToInstallListItem',
        			offlineMsgItemID: OFFLINE_CATALOG_LIST_ID,			
        			restRequestSuffix: 'catalog',
        			viewID: APP_CATALOG_VIEW_ID,		
        			listItems: Array(),
        			apps: Array(),
        			storageSaveKey: 'ibm_app_catalog_list_key',
        			listContainerID: 'catalogList',
        		    filterInProgress: true
        		}, this);
        	
        	this.inprogress = new AppList({
        			emptyMsgItemID: 'nothingToProgressListItem',
        			viewID: IN_PROGRESS_VIEW_ID,		
        			listItems: Array(),
        			apps: Array(),
        			storageSaveKey: 'ibm_app_inprogress_list_key',
        			listContainerID: 'inProgressList',
        		    filterInProgress: false
        		}, this);
        
        	
        	if(this.isAndroid) {
                // Nothing for now
        	}
        	else {
                // Move the tabbed control to the bottom
                var bottomPane = dom.byId(BOTTOM_PANE_ID);
                var tabNode = dom.byId(TAB_CONTROL_ID);
                
                tabNode.parentNode.removeChild(tabNode);
                bottomPane.appendChild(tabNode);
        	}
        			
        	if(this.isTablet) {
        		// Tablet UI fine tuning
        		domClass.remove(win.doc.documentElement, 'dj_phone');
        		domClass.add(win.doc.documentElement, 'dj_tablet');
        		domStyle.set(dom.byId(LEFT_SPLITTER_AREA_ID), 'display', 'block');
        		                
                // Dojo update the dj_tablet dynamically and this is not working 
                // for us on the Android tablets due to the virtual keyboard. Stick a 
                // constant ibmac_tablet and use it when we do not want things to change            
                domClass.add(win.doc.documentElement, 'ibmac_tablet');        		
                for(var i= 1; i < 4; i++){
                	var btn = dom.byId(LEFT_REFRESH_BUTTON_ID+i);
                    domStyle.set(btn, "display", "none");
                    // workaround for Heading.resize function, see Ticket 15218
                    domStyle.set(btn, "float", "none"); 
                	
                }
                for(var i= 1; i < 4; i++){
                	var icon = dom.byId(LEFT_OFFLINE_ICON_ID+i);
                    domStyle.set(icon, "display", "none");
                    // workaround for Heading.resize function, see Ticket 15218
                	domStyle.set(icon, "float", "none");
        		}
            }
        	else {    	
        		// Switch to use phone oriented ui
        		domClass.add(win.doc.documentElement, 'dj_phone');
        
        		var rightSide = dom.byId(RIGHT_SPLITTER_AREA_ID);
        
        		rightSide.appendChild(dom.byId(this.installed.viewID));
        		rightSide.appendChild(dom.byId(this.catalog.viewID));
        		rightSide.appendChild(dom.byId(this.inprogress.viewID));
        		
        		dom.byId(this.installed.listContainerID).setAttribute('stateful', 'false');
        		dom.byId(this.updated.listContainerID).setAttribute('stateful', 'false');
        		dom.byId(this.catalog.listContainerID).setAttribute('stateful', 'false');
        		dom.byId(this.inprogress.listContainerID).setAttribute('stateful', 'false');
        		
        		dom.byId(APP_INFO_HEADING_ID).setAttribute('back', this.bundle.Back );
        		dom.byId(APP_INFO_HEADING_ID).setAttribute('moveTo', MY_MOBILE_VIEW_ID);    	
                for(var i= 1; i < 5; i++){                    
                    var btn = dom.byId(REFRESH_BUTTON_ID+i);
                    domStyle.set(btn, "display", "none");
                    // workaround for Heading.resize function, see Ticket 15218                    
                    domStyle.set(btn, "float", "none");
                	
        		}
                for(var i= 1; i < 5; i++){
                    var icon = dom.byId(OFFLINE_ICON_ID+i);
                    domStyle.set(icon, "display", "none");
                    // workaround for Heading.resize function, see Ticket 15218                    
                	domStyle.set(icon, "float", "none");
                }
            }
                
        	// Parse the content manually
        	parser.parse();
        };
                
        MeapInstaller.prototype._setCredentials = function(pUsername, pPassword, pServerURL, pContextRoot) {	
        	
            console.log("Setting credentials for this session: User [" + pUsername + "] Password [" + pPassword + "] URL[" + pServerURL + "]");
            
        	this._serverURL = pServerURL;
        	this._username = pUsername;		
        	this._password = pPassword;	
        	this._contextRoot = pContextRoot;
        	
        	if(window.localStorage && window.localStorage.setItem){ 
        		window.localStorage.setItem(this.serverURLKey, pServerURL);
        		window.localStorage.setItem(this.usernameKey, pUsername);
        		if (pContextRoot)
        			window.localStorage.setItem(this.contextRootKey, pContextRoot);
        		else
        			window.localStorage.setItem(this.contextRootKey, "");
        	}	
        };

        
        MeapInstaller.prototype.getUsername = function() {
        	return this._username;
        };
        
        MeapInstaller.prototype.getPassword = function() {
        	return this._password;
        };
        
        MeapInstaller.prototype.getServerURL = function() {
            return this._serverURL + this.getContextRoot();
        };

        MeapInstaller.prototype.getContextRoot = function() {
            var ctxt = this._contextRoot ? this._contextRoot : this.bundle.defaultRootContext;
            
            return ctxt ? ('/' + ctxt + '/') : '/';
        };

        MeapInstaller.prototype.onFeedbackRequest = function() {        	
    		// look for the app in the list

        	if (this.offline || !FeedbackInfo || registry.byId(MY_MOBILE_TAB_ID).get('disabled')) {
        		return;
        	}
        	var feedbackInfo = FeedbackInfo;    
        	FeedbackInfo = null;
        	var index = this.installed._listItemIndexForPkg(feedbackInfo.pkg);
        	if (index < 0) {
        		console.log("onFeedbackRequest Failed to find installed package " + feedbackInfo.pkg);
        		return;
        	}
        	console.log("Initiating onFeedbackRequest for app " + feedbackInfo.pkg) ;       	
        	var applicationItem = this.installed.listItems[index];
        	// fake selection of application
    		applicationItem.set('selected', true);
    		this.applicationSelected(applicationItem._appInfo, this.installed);
            // initilize stars & comment if needed
    		if (feedbackInfo.stars && feedbackInfo.stars < 0 || feedbackInfo.stars > 5) 
                feedbackInfo.stars = 0;
            registry.byId(FEEDBACK_STARS_ID).setAttribute("value", feedbackInfo.stars);
    		feedbackInfo.feedback && registry.byId(FEEDBACK_TEXT_ID).set("value", feedbackInfo.feedback);
    		
    		// fake on click to app info rating
            registry.byId(APP_INFO_RATING_ID)._onClick({ });
			};													        			         	      	

        
        MeapInstaller.prototype.initialize = function() {
        	
        	this.icons = {};
        	this.reloadIcons();
        	
        	this._initializeUI();
        	this._initializei18n();
            	
        	// we save the lists in native code
        	
        	this.inprogress.replaceApps(this._readInProgress());	
        	this.installed.replaceApps(this._readInstalled());	
        };
        
        MeapInstaller.prototype.refreshLayout = function() {
        
        	// Nili - so I will be able to work in the meantime
        	
        	domStyle.set(dom.byId('content'), 'height', domStyle.get(dom.byId('content').parentNode, 'height') +'px');
        	
            var hTab = domStyle.get(dom.byId(TAB_CONTROL_ID), 'height'); //dom.byId(TAB_CONTROL_ID);
            var hView = domStyle.get(dom.byId('content'), 'height') - hTab;

            
            var splitter = registry.byId(TOP_VERTICAL_SPLITTER_ID);
            domStyle.set(splitter.domNode, 'height', domStyle.get(dom.byId('content'), 'height') +'px');
        	splitter && splitter.resize();
        	
            domStyle.set(registry.byId(SETTINGS_VIEW_ID).domNode, 'height', hView  +'px');
            domStyle.set(registry.byId(APP_MENU_VIEW_ID).domNode, 'height', hView  +'px');          
            domStyle.set(registry.byId(MY_MOBILE_VIEW_ID).domNode, 'height', hView  +'px');
            domStyle.set(registry.byId(APP_CATALOG_VIEW_ID).domNode, 'height', hView  +'px');
            domStyle.set(registry.byId(IN_PROGRESS_VIEW_ID).domNode, 'height', hView  +'px');
            domStyle.set(registry.byId(APP_INFO_VIEW_ID).domNode, 'height', hView  +'px');
            domStyle.set(registry.byId(TEXT_DETAILS_VIEW_ID).domNode, 'height', hView  +'px');          

            //registry.byId(SETTINGS_VIEW_ID).resize();
        };
        
        
        MeapInstaller.prototype.offlineMode = function(pEnabled, pFirstTime) { 
        	
        	console.log("PureMeap.offlineMode(" + pEnabled +")");
        	
    		// nofity UI if needed
    		if (pEnabled && this.notifyConnectionFailure) {
    			this.showWarningMessage(this.bundle.serverConnectionFailedError);    			
    		}
    		
    		this.notifyConnectionFailure = false;        	
        	if(this.offline == pEnabled){
        		return;
        	}
        	
        	this.offline = pEnabled;
        	var delay = pFirstTime ? 0 : 60000;
            
        	var offlineUpdate = dom.byId(OFFLINE_UPDATE_TEXT_ID);
        	var offlineCatalog = dom.byId(OFFLINE_CATALOG_TEXT_ID);
        	var offlineIcon = [];
        	for(var i = 1; i < 5; i++){
        		offlineIcon.push(dom.byId(OFFLINE_ICON_ID+i));
        	}
        	var leftOfflineIcon = [];
        	for(var i = 1; i < 4; i++){
        		leftOfflineIcon.push(dom.byId(LEFT_OFFLINE_ICON_ID+i));
        	}
        	
        	// update action buttons enable state according to offline mode.
        	var buttons = [CANCEL_BUTTON_ID, INSTALL_BUTTON_ID, REMOVE_BUTTON_ID, 
        	               FEEDBACK_SUBMIT_ID, SWITCH_BUTTON_ID, NOT_INSTALLED_BUTTON_ID, SWITCH_VER_BUTTON_ID];
        	
        	arr.forEach(buttons, function(button){
        		registry.byId(button).set("disabled", pEnabled);
        	});        	        
        	
    		// change tab bar icons according to offline state.
        	// Offline images are suffixed by "_off"
        	var suf =  pEnabled ? "_off" : "";
        	var suf2 =  pEnabled ? "_off" : "_des";
        	arr.forEach(["icon1", "icon2"], function(prop){
        		// Tab nbar buttons do not have a setter on "icon"
        		// must set the highlight and regular icons (properties names are "icon1" and "icons2")
        		var suffix = prop === "icon2" ? suf : suf2;
    			registry.byId(MY_MOBILE_TAB_ID).set(prop, "images/mymobiletab"+suffix+".png");
        		registry.byId(CATALOG_TAB_ID).set(prop, "images/appcatalogtab"+suffix+".png");
        		registry.byId(INPROGRESS_TAB_ID).set(prop, "images/inprogresstab"+suffix+".png");            		
    		});        	    		

        	if (pEnabled) {
        		// Change the text
        		offlineUpdate.innerHTML = this.bundle.noConnectionMessage;
        		offlineCatalog.innerHTML = this.bundle.noConnectionMessage;
        		if (this.isTablet)
	            	for(var i = 0; i < 4; i++){
            			domStyle.set(offlineIcon[i], "display", "inline");            			
            			domStyle.set(offlineIcon[i], "float", "right");
	            	}
        		else 
	            	for(var i = 0; i < 3; i++){
            			domStyle.set(leftOfflineIcon[i], "display", "inline");
            			domStyle.set(leftOfflineIcon[i], "float", "right");
	            	}
        		
        		// check mode in a min
        		if(!this.pingTimer) {
        			this.pingTimer = setTimeout(lang.hitch(this, this.pingServer), delay);
        		}        	      		
        	} 
        	else {
        		offlineUpdate.innerHTML = this.bundle.clickToRefreshMessage;
        		offlineCatalog.innerHTML = this.bundle.clickToRefreshMessage;
        		if (this.isTablet){
	            	for(var i = 0; i < 4; i++){
	            		offlineIcon[i].style.display = "none";
	                    // workaround for Heading.resize function, see Ticket 15218
	            		domStyle.set(offlineIcon[i], "float", "none");
	            	}
        		}else{
	            	for(var i = 0; i < 3; i++){
	            		leftOfflineIcon[i].style.display = "none";
	                    // workaround for Heading.resize function, see Ticket 15218
	            		domStyle.set(leftOfflineIcon[i], "float", "none");
	            	}
        		}
        		if(this.pingTimer) {
        			clearTimeout(this.pingTimer);
        			delete this.pingTimer;
        		}
        		
        		
        		this.onFeedbackRequest();
        	}
        
        	this.updated._updateEmptyMessage();	
        	this.catalog._updateEmptyMessage();
        	
        	var headings = [APP_INFO_HEADING_ID, TXT_INFO_HEADING_ID, USER_AREA_ID, MY_MOBILE_HEADER_ID, 
        	                CATALOG_HEADER_ID, IN_PROGRESS_HEADER_ID, SETTINGS_HEADER_ID];
            arr.forEach(headings, function(item){
            	registry.byId(item).resize();
            });
        };
        
        MeapInstaller.prototype.pingServer = function(completeHandler, errorHandler) {
                           
	        var pingURL = installerConnections.getPingPath(this.getServerURL());
			
			var errorFunction = lang.hitch(this, function(error, ioargs) {				
				delete this.pingTimer;
				if(error) {
					console.log("Exception cauth " + error);
				}
				offlineMode(true);
				if(errorHandler){
					errorHandler(error, ioargs);
				}
			});
			
			var completeFunction = lang.hitch(this, function(data, ioargs) {				
				delete this.pingTimer;
				var xhttp = ioargs.xhr;
	    		console.log("offlineMode retuned with status " + xhttp.status);
				if (xhttp.status == 200) {					
					offlineMode(false);
					if(completeHandler){
						completeHandler(data, ioargs);
					}
				} else {
					errorFunction(null, ioargs);
				}
			});
			                
			var xhrArgs = {
				    url: pingURL,
				    user: this.getUsername(),
				    password: this.getPassword(),	
				    load: completeFunction,
				    error: errorFunction,
				    sync: false,
				    timeout: 5000,
	    		    preventCache: true,
	    		    handleAs: "text"
			};
			
			installerConnections.xhrGet(xhrArgs);
        };
        
        MeapInstaller.prototype.reloadIcons = function() {
        
        	console.log("reloadIcon");
        	var localIcons = installerNative.getIconsCache();
        	if(localIcons) {
        	    this.icons = localIcons;
        	}        	
        };

        
        MeapInstaller.prototype._syncInstalledApplicationsWithServer = function() {
        	
        	var restURL = installerConnections.getInstalledApplicationListURL(this.getServerURL(), installerNative.getDeviceId());
        		
        	console.log("_syncInstalledApplicationsWithServer calling |" + restURL + "| ");
        	
        	var _this = this;
        	
        	var errorFunction = function(error, ioargs) {
        		if(error) {
        			console.log("Exception cauth " + error);
        		}
        		console.log("Failed to retrieve installed application list from server");
        	};
        	
        	var completeFunction = function(data, ioargs) {
        		var xhttp = ioargs.xhr;
        		console.log("|_syncInstalledApplicationsWithServer calling " + restURL + " returned with status|" +  xhttp.status);
        		
        		if (xhttp.status == 200) {
        			var data = JSON.parse(data);      			
        			data && data.items && installerNative.syncInstalledApplications(data.items);        			
        		}         		
        		else {
        		    errorFunction(null, ioargs);
        		}
        	};
        	
        	var xhrArgs = {
        		    url: restURL,			
        		    user: _this.getUsername(),
        		    password: _this.getPassword(),	
        		    load: completeFunction,
        		    error: errorFunction,
        		    sync: false,
        		    timeout: 5000,
        		    preventCache: true,
        		    handleAs: "text"
        	};
        	
        	installerConnections.xhrGet(xhrArgs);      	
        };
        
        MeapInstaller.prototype.reload = function(pAfterStartup, pShowProgress) {
        
        	console.log("reload [pAfterStartup pShowProgress]=[" + pAfterStartup + "," + pShowProgress);
        	
        	var progressIndicator = null;
        	var postLoadFunc = null;
        	var count = 2;
        	
        	if (pShowProgress) {
        		
        		progressIndicator = dojox.mobile.ProgressIndicator.getInstance();
                registry.byId(USER_AREA_ID).domNode.appendChild(progressIndicator.domNode);
                
                postLoadFunc = function (error) {    
            		if (progressIndicator) {
            			count = count -1;
            			if (error || count == 0) {
            				progressIndicator.stop();
            				// Nili - workaround for the progressIndicator not disappearing completely
            				registry.byId(USER_AREA_ID).resize();
            				progressIndicator = null;
            			}
            		}
            	};
            	
                progressIndicator.start();
        	}
        	
        	
        	
        	if(!pAfterStartup) {		
        		var installed = this._readInstalled();
        		
        		if(installed == null) 
        			// some error 
        			this.installed.loadApplicationsIntoList(false);
        		else 
        			this.installed.replaceApps(installed);
        			
        		this.inprogress.replaceApps(this._readInProgress());	
        	}
        	
            this.updated.loadApplicationsIntoList(true, postLoadFunc);
            this.catalog.loadApplicationsIntoList(true, postLoadFunc);    
            this.onFeedbackRequest();
        };
        
        MeapInstaller.prototype.inProgressNotification = function(pTaskUid, pMsg) {
        	console.log("inProgressNotification for task " + pTaskUid + "with message " + pMsg);
        	
        	var appToNotify = this.inprogress._appByTaskUid(pTaskUid);
        	if (appToNotify) {		
        		appToNotify.progress_notification = pMsg;
        		if (this.selected && 
        			this.selected.list == this.inprogress && 
        			this.selected.app == appToNotify) {
        			// update the view 
        			dom.byId(PROG_INFO_STATUS_ID).innerHTML = pMsg;			
        			dom.byId(STATUS_LIST_ID).style.display = 'block';	
        		}						
        	}
        
        };
        
        MeapInstaller.prototype.cancelInProgress = function(pMsg) {
        
        	console.log("cancelInProgress");
        	
        	this.showWarningMessage(pMsg); 	    
        };
        
        MeapInstaller.prototype.showWarningMessage = function(pMsg) {
        	
        	alert(pMsg);
        };
        
        MeapInstaller.prototype.listItemLabel = function(pText) {
        	
        	return this._labelAtLength(pText, 20);
        };
        
        MeapInstaller.prototype.dataListLabel = MeapInstaller.prototype.viewHeadingLabel = function(pText) {
        	
        	if(this.isTablet || this.isLandscape) {
        		return this._labelAtLength(pText, 30);
        	}
        	else {
        		return this._labelAtLength(pText, 15);
        	}
        };
        
        MeapInstaller.prototype._labelAtLength = function(pText, pLenght) {
        	
        	return pText && pText.length > pLenght ? pText.substring(0, pLenght - 3) + "..." : pText;
        };
        
        MeapInstaller.prototype.applicationSelected = function(pApplication, pListInfo) {
        	
        	// A selection in any of the lists below should unselect an existing selection in any of the others
        	this._coordinateSelections(pListInfo.listContainerID, [ 'installedList', 'updatedList' ]);
        	
            // Dojo generates the back button once and later do not bother to update it...
            // Update the back button with the latest back destination
        	if(registry.byId(APP_INFO_HEADING_ID).backButton) {
        	    registry.byId(APP_INFO_HEADING_ID).backButton.set("moveTo", pListInfo.viewID);
        	}
        	
        	registry.byId(APP_INFO_HEADING_ID).set("label", this.viewHeadingLabel(pApplication.label));        	        	
        	registry.byId("textDetailsHeadingWidget").set("label", this.dataListLabel(pApplication.label));        	
        	
        	var trimedTxt = this.dataListLabel(pApplication.description);
        	
        	if(trimedTxt != pApplication.description) {
        		var navOption = registry.byId(APP_INFO_DESCR_NAV_ID);
        		domStyle.set(navOption.domNode, 'display', 'block');
        		domStyle.set(registry.byId(APP_INFO_DESCRIPTION_ID).domNode, 'display', 'none');
        		
        		navOption.set('rightText', trimedTxt);
        		navOption.__fullText = pApplication.description;
        	}
        	else {
        		var noNavOption = registry.byId(APP_INFO_DESCRIPTION_ID);
        		domStyle.set(noNavOption.domNode, 'display', 'block');
        		domStyle.set(registry.byId(APP_INFO_DESCR_NAV_ID).domNode, 'display', 'none');
        		noNavOption.set('rightText', pApplication.description);		
        	}
        
        	registry.byId(APP_INFO_VERSION_ID).set('rightText', pApplication.version);
        	registry.byId(APP_INFO_MANDATORY_ID).set('rightText', pApplication.mandatory == 'Y' ? this.bundle.Yes : this.bundle.No);
        	        
        	
            /*
             * On Android, when we hide (display=none) a ListItem, the corners 
             * of the list has holes in them. Remove the first and last dom nodes 
             * from the dom tree and than add them back when they should be 
             * seen.
             * 
             * First ListItem is APP_INFO_PKG_ID
             * Last  ListItem is APP_INFO_RATING_ID
             */
            var appInfoListWidget = registry.byId(APP_INFO_LIST_ID);
            
            trimedTxt = this.dataListLabel(pApplication.pkg);
            if(trimedTxt != pApplication.pkg) {
                var navOption = registry.byId(APP_INFO_PKG_NAV_ID);
                domStyle.set(navOption.domNode, 'display', 'block');              
                navOption.set('rightText', trimedTxt);
                navOption.__fullText = pApplication.pkg;
                
                if(!appInfoListWidget.__APP_INFO_PKG_ID) {
                    appInfoListWidget.__APP_INFO_PKG_ID = registry.byId(APP_INFO_PKG_ID);
                    appInfoListWidget.removeChild(appInfoListWidget.__APP_INFO_PKG_ID);
                }               
            }
            else {
                
                if(appInfoListWidget.__APP_INFO_PKG_ID) {
                    appInfoListWidget.addChild(appInfoListWidget.__APP_INFO_PKG_ID, 0);
                    appInfoListWidget.__APP_INFO_PKG_ID = null;
                }               
                
                var noNavOption = registry.byId(APP_INFO_PKG_ID);
                domStyle.set(noNavOption.domNode, 'display', 'block');
                domStyle.set(registry.byId(APP_INFO_PKG_NAV_ID).domNode, 'display', 'none');
                noNavOption.set('rightText', pApplication.pkg);     
            }
        	
        	this.selected.app = pApplication;
        	this.selected.list = pListInfo;	
        	
        	// Manage the content of the switch view:
        	// 1: sets the current version number in the label		
        	// 2: gets all version numbers available for the application
        	// 3: hides "switch now" button
        	dom.byId(SWITCH_VER_TEXT_ID).innerHTML = pApplication.version;	
        	
        	domStyle.set(dom.byId(SWITCH_VER_BUTTON_LIST_ID), 'display', 'none');
        		
        	
        	// Manage the show/hide of the progress information button
        	if(pListInfo == this.inprogress && pApplication.progress_notification) {
        		dom.byId(PROG_INFO_STATUS_ID).innerHTML = pApplication.progress_notification;
        		dom.byId(STATUS_LIST_ID).style.display = 'block';		
        	} 
        	else {
        		dom.byId(STATUS_LIST_ID).style.display = 'none';
        	}
        	
        	// Manage the show/hide of the install button 
        	var installProfileButton = registry.byId(INSTALL_PROFILE_BUTTON_ID);  
        	if(pListInfo == this.updated || pListInfo == this.catalog) {					
        		
        		domStyle.set(dom.byId(APP_INSTALL_LIST_ID), 'display', 'block');
        		domStyle.set(registry.byId(INSTALL_BUTTON_ID).domNode, 'display', '');
        		
        		installProfileButton && html.style(installProfileButton.domNode, 'display', 
        			pApplication.os == OS_HTML5 ? 'none' : '');
        	}
        	else {
        		domStyle.set(dom.byId(APP_INSTALL_LIST_ID), 'display', 'none');			
        	}
        	
        	
        	// Manage the display of the remove and switch version buttons
            if (pListInfo == this.installed) {
               
            	pListInfo.loadApplicationVersionsIntoList(pApplication, true);
            	
                var _numberButtons = 0;
               
                // The list is installed, so we need to display the container:
                domStyle.set(dom.byId(APP_REMOVE_LIST_ID), 'display', 'block');
               
                // Check to see if we can remove the application
                if (pApplication.os == 'iOS') {
                    domStyle.set(registry.byId(REMOVE_BUTTON_ID).domNode, 'display', 'none');
                    domStyle.set(registry.byId(NOT_INSTALLED_BUTTON_ID).domNode, 'display', '');
                    _numberButtons++;
                } 
                else {
                    domStyle.set(registry.byId(NOT_INSTALLED_BUTTON_ID).domNode, 'display', 'none');
                    domStyle.set(registry.byId(REMOVE_BUTTON_ID).domNode, 'display', '');
                    _numberButtons++;
                }
               
               
               
            } else {
                // Hide the remove list section - the application is not installed
                domStyle.set(dom.byId(APP_REMOVE_LIST_ID), 'display', 'none');
            }
                        
            // Manage the show/hide of the cancel button
            if (pListInfo == this.inprogress) {
                var _numButtons = 0;
                
                // Start off by displaying the container        
                domStyle.set(dom.byId(APP_CANCEL_LIST_ID), 'display', 'block');
                
                if (this.isAndroid || pApplication.os == OS_HTML5) {
                    _numButtons++;
                    domStyle.set(registry.byId(CANCEL_BUTTON_ID).domNode, 'display', '');
                } 
                else {
                    domStyle.set(registry.byId(CANCEL_BUTTON_ID).domNode, 'display', 'none');
                }
                
                if (pApplication.os == 'iOS') {
                    domStyle.set(registry.byId(NOT_IN_PROGRESS_BUTTON_ID).domNode, 'display', '');
                    _numButtons++;
                } 
                else {
                    domStyle.set(registry.byId(NOT_IN_PROGRESS_BUTTON_ID).domNode, 'display', 'none');
                }
                
                if (_numButtons == 0) {
                    domStyle.set(dom.byId(APP_CANCEL_LIST_ID), 'display', 'none');
                }                                
            } 
            else {
                domStyle.set(dom.byId(APP_CANCEL_LIST_ID), 'display', 'none');
            }
            
            // Manage the show/hide of the feedback list itemn    
            if(pListInfo == this.installed) {
                if(appInfoListWidget.__APP_INFO_RATING_ID) {
                    appInfoListWidget.addChild(appInfoListWidget.__APP_INFO_RATING_ID); // last 
                    appInfoListWidget.__APP_INFO_RATING_ID = null;
                }               
                // domStyle.set(registry.byId(APP_INFO_RATING_ID).domNode, 'display', 'block');
            } 
            else {
                // domStyle.set(registry.byId(APP_INFO_RATING_ID).domNode, 'display', 'none');
                if(!appInfoListWidget.__APP_INFO_RATING_ID) {
                    appInfoListWidget.__APP_INFO_RATING_ID = registry.byId(APP_INFO_RATING_ID);
                    appInfoListWidget.removeChild(appInfoListWidget.__APP_INFO_RATING_ID);
                }               
            }           
        	
        	if (this.isTablet) {
        		// Make sure appInfoView is shown when selecting an application
        		var appInfo = registry.byId(APP_INFO_VIEW_ID);
        		appInfo.set('selected', true);
        		appInfo.set('_visible', true);
        		domStyle.set(appInfo.domNode, 'display', '');
        		// force resize of heading otherwise label won't be centered
        		registry.byId(APP_INFO_HEADING_ID).resize();
        	}
        	
        	this._assesMoveBackRequired(APP_INFO_VIEW_ID);
        };
        
        MeapInstaller.prototype._textDetailsSelected = function(pText, pTextType) {
        	dom.byId(TEXT_DETAILS_CAT_ID).innerHTML = pTextType;
        	dom.byId(TEXT_DETAILS_TEXT_ID).innerHTML = pText;
        	this._assesMoveBackRequired(TEXT_DETAILS_VIEW_ID);
        };
        
        MeapInstaller.prototype._installSelected = function() {
        	// ping the server before installing the application     
        	this._pingBeforeAction(APP_INFO_VIEW_ID, this._doInstallSelected);
        };
        
        MeapInstaller.prototype._doInstallSelected = function() {
        	
        	var app = this.selected.app;
        	if(app) {
        		app.task_uid = app.pkg + '-' + app.version + '-' + 
        		               (new Date()).getTime();// issued in dojo1.7b2 dojox.uuid.generateRandomUuid();
        		var installing = installerNative.installApplication(app, json.toJson(app));
        		
        		if(installing) {
        			//app.progress_notification = null;
        			this.inprogress.addApp(app);
        			
        			// do not show the app in all lists
        			this.catalog.hideListItem(app);
        			this.updated.hideListItem(app);
        			
        			this.applicationSelected(app, this.inprogress);
        
        			registry.byId(INPROGRESS_TAB_ID)._onClick({ });
        		}
        		else {
        			this.showWarningMessage( this.bundle.installationFailedError.replace("%1",app.label) );
        		}			
        	}
        };
        
        MeapInstaller.prototype._pingBeforeAction = function(/*String*/view, /*Function*/action) {
        	
        	// ping the server before installing the application
        	
        	var prog = dojox.mobile.ProgressIndicator.getInstance();
            registry.byId(view).domNode.appendChild(prog.domNode);
            
            var thisAction =  lang.hitch(this, action);
            var func = lang.hitch(this, function(){
            	if(prog){
					prog.stop();
				}
            	thisAction();
            });
                    	
        	var errorFunc = lang.hitch(this, function(error, ioargs) {
        		if(prog){
					prog.stop();
				}
				this.showWarningMessage(this.bundle.serverConnectionFailedError);				        	
        	});        	       
        	
            prog.start();
                			        	      
        	this.pingServer(func, errorFunc);
        };
        
        MeapInstaller.prototype._removeSelected = function() {
        	// ping the server before removing the application
        	this._pingBeforeAction(APP_INFO_VIEW_ID, this._doRemoveSelected);
        };
        
        MeapInstaller.prototype._doRemoveSelected = function() {
        	
        	// If we are running in a phone, slide the view back to the list of apps	
        	if(this.selected.app && this.selected.list == this.installed) {
        		
        		var app = this.selected.app;
        		app.task_uid = app.pkg + '-' + app.version + '-' + 
                	(new Date()).getTime();// issued in dojo1.7b2 dojox.uuid.generateRandomUuid();		
        		installerNative.removeApplication(app);
        		
        		this.installed.removeApp(app);
        	
        		// move to inprogress
        		this.inprogress.addApp(app);
        		registry.byId(INPROGRESS_TAB_ID)._onClick({ });
        
        	}	
        };
        
        MeapInstaller.prototype._reportNotInstalled = function() {
            // If we are running in a phone, slide the view back to the list of apps	
        	if(this.selected.app && this.selected.list == this.installed) {
        		
        		var app = this.selected.app;
        		app.task_uid = app.pkg + '-' + app.version + '-' + 
                (new Date()).getTime(); // issued in dojo1.7b2 dojox.uuid.generateRandomUuid();		
                
                // Remove the Application from the Database	       
        		installerNative.removeApplication(app);
        		
                // Remove the Application from the Lists
                this.installed.removeApp(app);
        
        		this.inprogress.addApp(app);
        		registry.byId(INPROGRESS_TAB_ID)._onClick({ });		
        	}	    
        };
        
        
        MeapInstaller.prototype._cancelSelected = function() {
        	if(this.selected.app && this.selected.list == this.inprogress) {		
        		var app = this.selected.app;
        		installerNative.cancelApplication(app);
        		
        		this.showWarningMessage( this.bundle.cancelTryMessage.replace("%1",app.label) );
        		
        		this.inprogress.removeApp(app);
        		
        		this.updated.showListItem(app);
        		this.catalog.showListItem(app);		
        		
        		registry.byId(MY_MOBILE_TAB_ID)._onClick({ });		
        	}	
        };
        
        MeapInstaller.prototype._reportNotInProgressSelected = function() {
        	if(this.selected.app && this.selected.list == this.inprogress) {		
        		var app = this.selected.app;
        		
        		// Cancel the Application
        		installerNative.cancelApplication(app);		
                
        		// Remove and Add it to the normal lists
        		this.inprogress.removeApp(app);
        		this.updated.showListItem(app);
        		this.catalog.showListItem(app);		
        		
        		registry.byId(MY_MOBILE_TAB_ID)._onClick({ });		
        	}	
        };               
        
        MeapInstaller.prototype._switchSelected = function() {        	
        	// display the version switch view and call a callback function when transition is done
        	registry.byId(APP_INFO_VIEW_ID).performTransition(SWITCH_VIEW_ID,1,'slide');	
        };
        
        
        MeapInstaller.prototype._installProfileSelected = function() {
        
        	if(this.selected.app) 
        		if (!this.installProfile || !this.installProfile(this.selected.app)) 
        			this.showWarningMessage( this.bundle.installationFailedError.replace("%1", this.selected.app.label) );	
        };
        
        
        MeapInstaller.prototype._onTabSwitch = function(pListArray) {
        
        	
        	//  clicking on the settings tab: hide the splitpane
        	if(pListArray == "settings"){
        		domStyle.set( dom.byId(MAIN_APP_SPLITTER_ID), "display","none");
        		domStyle.set( dom.byId(SETTINGS_VIEW_ID), "display","block");
        		this.refreshLayout();
        		return;
        	}
        	else {
        		domStyle.set( dom.byId(MAIN_APP_SPLITTER_ID), "display","block");
        		domStyle.set( dom.byId(SETTINGS_VIEW_ID), "display","none");
        		this.refreshLayout();
        	}
        
        	// Scroll back to the top of the screen
        	
        	var scrollableView = registry.byId(APP_INFO_VIEW_ID);
        	if(scrollableView && scrollableView.slideTo)
        		scrollableView.slideTo({x:0, y:0}, 0.5, 'linear');        	
        		
        	// Check if we have a splitted display (and than selecting an app is 
        	// important)
        	if(this.isTablet) {
        	    domStyle.set(registry.byId(NO_APP_SELECTED_VIEW_ID).domNode, 'display', 'none');
        	    
        		for(var i = 0 ; i < pListArray.length ; i++) {
        			var selected = pListArray[i].getSelectedApp();
        			
        			if(selected) {
        				this.applicationSelected(selected, pListArray[i]);
        				return;
        			}
        		}
        		
        		// Nothing selected, the first app in the lists will be selected
        		for(var i = 0 ; i < pListArray.length ; i++) {
        			
        			if(pListArray[i].listItems.length > 0) {
        				// Fake a click on the control
                        pListArray[i].listItems[0]._onClick({ });
                        return;
        			}
        		}
        		
        		// Nothing to select, hide info views
        		domStyle.set(registry.byId(APP_INFO_VIEW_ID).domNode, 'display', 'none');
        		domStyle.set(registry.byId(TEXT_DETAILS_VIEW_ID).domNode, 'display', 'none');
        		domStyle.set(registry.byId(NO_APP_SELECTED_VIEW_ID).domNode, 'display', 'block');
        		registry.byId(NO_APP_SELECTED_VIEW_ID).resize();
        	}		
            else {
                // On the phone, roll back just scroll the menus 
                var listView = registry.byId(pListArray[0].viewID); 
                scrollableView = listView;
                
                while(scrollableView && !scrollableView.slideTo) 
                    scrollableView = registry.getEnclosingWidget(scrollableView.domNode.parentNode);
                                                              
                if(scrollableView){                	                   
                	scrollableView.slideTo({x:0, y:0}, 0.5, 'linear');                	
                }
            }   
        	            
            // Make sure a list is selected
            this.selected.list = pListArray[0];                 	
        };
        
        MeapInstaller.prototype._coordinateSelections = function(pNewListID, pLists) {
        	
        	var oldList = this.selected.list;
        	var oldListID = oldList && oldList.listContainerID;
        	
        	if (!oldListID || oldListID == pNewListID)
        		return; // Same list, nothing to do
        	
        	var belongs = [false, false];
        	for (var i = 0; i < pLists.length; ++i) {
        		if (oldListID == pLists[i])
        			belongs[0] = true;
        	    if (pNewListID == pLists[i])
        	    	belongs[1] = true;
        	}
        	if (!belongs[0] || !belongs[1])
        		return;
        
        	var items = oldList.listItems;
        	for (var i = 0; i < items.length; ++i) {
        	    items[i].set('selected', false);
        	}
        };
        
        MeapInstaller.prototype.moveBack = function() {
        	
        	// 1. If the text info view is visible, step back
        	// 2. If we are not in a tablet and app info is visible, step back
        	// otherwise, ignore
        	var nextView = null;
        	
        	
        	var currView = registry.byId(TEXT_DETAILS_VIEW_ID).getShowingView();

        	if(currView == registry.byId(TEXT_DETAILS_VIEW_ID)) {
        		nextView = APP_INFO_VIEW_ID;
        		
        		// Move back
        		var txtInfo = registry.byId(TXT_INFO_HEADING_ID);
        		txtInfo.backButton.makeTransition({});
        		//txtInfo.goTo(txtInfo.moveTo, txtInfo.href);
        	}
        	else if(currView == registry.byId(APP_INFO_VIEW_ID) &&
        			!this.isTablet) {
        		// Move back_
        		var appInfo = registry.byId(APP_INFO_HEADING_ID);
        		//ppInfo.goTo(appInfo.moveTo, appInfo.href);
        		appInfo.backButton.makeTransition({});
        	} else if(currView == registry.byId(FEEDBACK_VIEW_ID) &&
        			!this.isTablet) {
        		// Move back_
        		var feedbackInfo = registry.byId(FEEDBACK_HEADER_ID);
        		//ppInfo.goTo(appInfo.moveTo, appInfo.href);
        		feedbackInfo.backButton.makeTransition({});
        	} else if(currView == registry.byId(SWITCH_VIEW_ID) &&
        			!this.isTablet) {
        		// Move back_
        		var switchInfo = registry.byId(SWITCH_VERSION_HEADER_ID);
        		//ppInfo.goTo(appInfo.moveTo, appInfo.href);
        		switchInfo.backButton.makeTransition({});
        	}
        	
        	this._assesMoveBackRequired(nextView);
        };
        
        MeapInstaller.prototype._assesMoveBackRequired = function(pViewShown) {
        	
        	if(pViewShown == TEXT_DETAILS_VIEW_ID) {
        		document.addEventListener("backbutton", sendOnBack, false); 
        	} else if(pViewShown == APP_INFO_VIEW_ID && !this.isTablet) {
        		document.addEventListener("backbutton", sendOnBack, false); 
        	} else {
        		document.removeEventListener("backbutton", sendOnBack, false); 
        	}
        };
        
        MeapInstaller.prototype._readInProgress = function() {
        	
        	var inprogg = installerNative.getInprogressApplications();
        	if(inprogg && inprogg.length > 0) {
        		// The information that we are getting from the native part is not
        		// Complete. We use the objects in installed.apps and inprogres.apps
        		var inproggApps = Array();
        		
        		for(var i = 0 ; i < inprogg.length ; i++ ) {							
        			var fullAppInfo = json.fromJson(inprogg[i].json);
        			fullAppInfo.progress_notification = inprogg[i].prog_msg;
        			inproggApps.push(fullAppInfo);
        		}
        		
        		return inproggApps;
        	}
        
        	
        	return [];
        };
        
        MeapInstaller.prototype._readInstalled = function() {
        	
        	var apps = installerNative.getInstalledApplications();
        
        	if(apps && apps.length > 0) {
        		// The information that we are getting from the native part is not
        		// Complete. We use the objects in installed.apps and inprogres.apps
        		var installedApps = Array();
        		
        		for(var i = 0 ; i < apps.length ; i++ ) {			
        			var fullAppInfo = json.fromJson(apps[i].json);
        			installedApps.push(fullAppInfo);		
        		}
        		
        		return installedApps;
        	}
        	
        	return [];
        };
        
        MeapInstaller.prototype._installSelectedWithVersion = function(versionInfo) {
        	
        	var version = versionInfo.version;
        	var currentApp = this.selected.app;
        	
        	console.log("calling |" + versionInfo.link + "| ");
        	
        	var _this = this;
        	
        	var errorFunction = function(error, ioargs) {
        		var xhttp = ioargs.xhr;
        		if(error) {
        			console.log("Exception cauth " + error + "on URL|" + versionInfo.link);
        		}
        		var msg = _this.bundle.installationFailedError.replace("%1", currentApp.label);
    			_this.showWarningMessage(msg);
        	};
        	
        	var completeFunction = function(data, ioargs) {
        		var xhttp = ioargs.xhr;
        		console.log("|calling " + versionInfo.link + " returned with status|" +  xhttp.status);
        		if (xhttp.status == 200) {
        			var app = JSON.parse(data);	
        		app.task_uid = app.pkg + '-' + version + '-' + 
        		               (new Date()).getTime();// issued in dojo1.7b2 dojox.uuid.generateRandomUuid();
        		
        		var installing = installerNative.installApplication(app);
        		
        		if(installing) {
        			//app.progress_notification = null;
            			_this.inprogress.addApp(app);
        			
        			// do not show the app in all lists
            			_this.catalog.hideListItem(app);
            			_this.updated.hideListItem(app);
        			
            			_this.applicationSelected(app, _this.inprogress);
        
        			registry.byId(INPROGRESS_TAB_ID)._onClick({ });
        		}
        		else {
            			var msg = _this.bundle.installationFailedError.replace("%1", app.label)
            			_this.showWarningMessage(msg);
        		}			
        		} else {
        			errorFunction(null, ioargs);
        	}
        };
        
        	var xhrArgs = {
        		    url: versionInfo.link,			
        		    user: _this.getUsername(),
        		    password: _this.getPassword(),	
        		    load: completeFunction,
        		    error: errorFunction,
        		    sync: false,
        		    timeout: 5000,
        		    preventCache: true,
        		    handleAs: "text"
        	};        	
        	
        	installerConnections.xhrGet(xhrArgs);
        };
        
        MeapInstaller.prototype._switchToSelected = function() {
        	// ping the server before installing the application     
        	this._pingBeforeAction(SWITCH_VIEW_ID, this._doSwitchToSelected);
        };
        
        MeapInstaller.prototype._doSwitchToSelected = function() {
        	if(this._versionToInstall){
        		this._installSelectedWithVersion(this._versionToInstall);
        	}
        };
        
        MeapInstaller.prototype._clearFeedback = function() {
 			registry.byId(FEEDBACK_STARS_ID).setAttribute("value", 3);		
        	registry.byId(FEEDBACK_TEXT_ID).set("value", "");
        };
        
        MeapInstaller.prototype._submitFeedbackOfSelected = function() {
            
        	var submitButton = registry.byId(FEEDBACK_SUBMIT_ID);        	
        	submitButton.set("disabled", true);
        	
            var prog = dojox.mobile.ProgressIndicator.getInstance();
            registry.byId(FEEDBACK_VIEW_ID).domNode.appendChild(prog.domNode);
            
            prog.start();
            var rating = registry.byId(FEEDBACK_STARS_ID).get('value') * 2;    
            if(rating < 0 || rating > 10) {
                rating = 1;
            }
            
            var comments = registry.byId(FEEDBACK_TEXT_ID).get('value'); 
            if(!comments) {
                comments = '';
            }
            
            var app = this.selected.app;
            var feedbackUrl = installerConnections.getFeedbackURL(this.getServerURL(), app);
            
            console.log("------> url    : " + feedbackUrl);
            console.log("------> rating : " + rating);
            console.log("------> message: " + comments);

            var _this = this;
            var errorFunction = function(error, ioargs) {
            	if(prog){
            		prog.stop();
            	};
            	submitButton.set("disabled", false);
            	if(error) {
        			console.log("Exception cauth " + error);
        		}
            	_this.showWarningMessage(_this.bundle.feedbackFailedError);
            };
            
            var completeFunction = function(data, ioargs) {
            	if(prog){
            		prog.stop();
            	};
            	submitButton.set("disabled", false);
            	
            	var xhttp = ioargs.xhr;
            	console.log("|calling " + feedbackUrl+ " with status|" +  xhttp.status);
                if (xhttp.status == 200) {
                	_this.showWarningMessage(_this.bundle.feedbackSuccessMessage);
                	_this._clearFeedback();
                } else {
                	errorFunction(null, ioargs);
                }
            };
            
            var xhrArgs = {
                    url: feedbackUrl,
                    user: this.getUsername(),
                    password: this.getPassword(),  
                    postData: JSON.stringify({
	                        'device_id' : installerNative.getDeviceId(),
	                        'comment'   : comments,
	                        'rating'    : rating
                    	}),
                    headers: { "Content-Type": "application/json"},
                    load: completeFunction,
                    error: errorFunction,
                    timeout: 5000,
        		    preventCache: true,
        		    handleAs: "text"
            };
            
            installerConnections.xhrPost(xhrArgs);                           
        };
                
        MeapInstaller.prototype.onNewSettings = function (pUser, pPassword, pURL, pContextRoot) {
            
            this._setCredentials(pUser, pPassword, pURL, pContextRoot); 
            
            var pingURL = installerConnections.getPingPath(this.getServerURL());
            
            var prog = dojox.mobile.ProgressIndicator.getInstance();
            registry.byId(SETTINGS_VIEW_ID).domNode.appendChild(prog.domNode);
            prog.start();
            
            var _this = this;            
            var errorFunction = function(error) {
            	prog && prog.stop();
            	prog = null;
            	var detailedCause = "";
            	if(error) {
        			console.log("Error connecting to server [code, msg, status] = " 
        					+ error.errorCode + ", "
        					+ error.errorMsg + ", "
        					+ error.httpCode);
        			if (error.errorCode == navigator.installer.ERROR_CODE.SECURITY_FAIL) {
        				detailedCause = "\n" + _this.bundle.serverConnectionAuthenticationError;
        			} else  if (error.errorCode == navigator.installer.ERROR_CODE.CONNECT_FAIL) {
        				detailedCause = "\n" + _this.bundle.serverUnreachableError;
        		}
        		}
                _this.notifyConnectionFailure = false;
                offlineMode(true);
                var errorMsg = _this.bundle.serverConnectionFailedError + detailedCause;
    			_this.showWarningMessage(errorMsg);
                installerSettings.onError(errorMsg);
            };
            
            var completeFunction = function() {
            	prog && prog.stop();
            	prog = null;

                console.log("Connection to server success! " + _this.getServerURL() );
                
                    installerSettings.onSuccess();
     
                            _this._syncInstalledApplicationsWithServer();
                
                            registry.byId(MY_MOBILE_TAB_ID).set("disabled", false);
                            registry.byId(CATALOG_TAB_ID).set("disabled", false);
                            registry.byId(INPROGRESS_TAB_ID).set("disabled", false);                                                 
                            registry.byId(MY_MOBILE_TAB_ID)._onClick({ });                  
   
                 _this.reload(false, true);
            };
                            
            installerNative.updateConnection(_this.getUsername(), _this.getPassword(), _this.getServerURL(), completeFunction, errorFunction); 
            
        };
        
        MeapInstaller.prototype._initializeUI = function() {
        
        	var _this = this;
        
            connect.connect(registry.byId(APP_INFO_DESCR_NAV_ID), "onClick", registry.byId(APP_INFO_DESCR_NAV_ID), function() {
            	_this._textDetailsSelected(this.__fullText, "Description");
            });
        
            connect.connect(registry.byId(APP_INFO_PKG_NAV_ID), "onClick", registry.byId(APP_INFO_PKG_NAV_ID), function() {
            	_this._textDetailsSelected(this.__fullText, "Package");
            });
        
            connect.connect(registry.byId(INSTALL_BUTTON_ID), "onClick", registry.byId(APP_INFO_VIEW_ID), function() {
            	_this._installSelected();
            });
            
            connect.connect(registry.byId(REMOVE_BUTTON_ID), "onClick", registry.byId(APP_INFO_VIEW_ID), function() {
            	_this._removeSelected();
            });
            
            connect.connect(registry.byId(NOT_INSTALLED_BUTTON_ID), "onClick", registry.byId(APP_INFO_VIEW_ID), function() {
                _this._reportNotInstalled();
            });
            
            connect.connect(registry.byId(CANCEL_BUTTON_ID), "onClick", registry.byId(APP_INFO_VIEW_ID), function() {
            	_this._cancelSelected();
            });
            
            connect.connect(registry.byId(NOT_IN_PROGRESS_BUTTON_ID), "onClick", registry.byId(APP_INFO_VIEW_ID), function() {
                _this._reportNotInProgressSelected();
            });
            
            connect.connect(registry.byId(SWITCH_BUTTON_ID), "onClick", registry.byId(APP_INFO_VIEW_ID), function() {
            	_this._switchSelected();
            });
            
            
            var installProfileButton = registry.byId(INSTALL_PROFILE_BUTTON_ID);
            if (installProfileButton) {
                connect.connect(installProfileButton, "onClick", registry.byId(APP_INFO_VIEW_ID), function() {
                	_this._installProfileSelected();
                });
            }
        
            var settingsTab = registry.byId(SETTINGS_TAB_ID);
            var myMobileTab = registry.byId(MY_MOBILE_TAB_ID);
            var inProgressTab = registry.byId(INPROGRESS_TAB_ID);
            var catalogTab = registry.byId(CATALOG_TAB_ID);
            
            myMobileTab.onTouchStart = inProgressTab.onTouchStart = catalogTab.onTouchStart  = function() {
                if(this.get('disabled')) {
                    return false;
                }
                return true;
            };
            
            connect.connect(myMobileTab, "onClick", function() {
            	_this._onTabSwitch([_this.installed, _this.updated]);
            });
                        
            connect.connect(inProgressTab, "onClick", function() {
                _this._onTabSwitch([_this.inprogress]);
            });
            connect.connect(catalogTab, "onClick", function() {
                _this._onTabSwitch([_this.catalog]);
            });
            connect.connect(settingsTab, "onClick", function() {
            	_this._onTabSwitch("settings");
            });
            myMobileTab.set("disabled", true);
            inProgressTab.set("disabled", true);
            catalogTab.set("disabled", true);
            
            connect.connect(registry.byId(OFFLINE_UPDATE_LIST_ID).domNode, "onclick", function() {
            	_this.notifyConnectionFailure = true;
            	_this.reload(false, true);	
        	});
            
            connect.connect(registry.byId(OFFLINE_CATALOG_LIST_ID).domNode, "onclick", function() {
            	_this.notifyConnectionFailure = true;
        		_this.reload(false, true);
        	});
                        
            // install listeners for the "switch" button of the version switch view
            connect.connect(registry.byId(SWITCH_VER_BUTTON_ID), "onClick", registry.byId(APP_INFO_VIEW_ID), function() {
            	_this._switchToSelected();
            });     
           
            // install listeners for the version list of the version switch view 
            connect.connect(registry.byId(SWITCH_VER_LIST_ID), "onCheckStateChanged", function(listItem, newState) {    	
            	if(newState==true){
            		_this._versionToInstall = listItem._versionInfo;
            		domStyle.set(dom.byId(SWITCH_VER_BUTTON_LIST_ID), 'display', 'block');
            	}
        	});    
            
            // install listeners for wigdets of the feedback & rating view: submit button
            connect.connect(registry.byId(FEEDBACK_SUBMIT_ID), "onClick", registry.byId(APP_INFO_VIEW_ID), function() {
            	_this._submitFeedbackOfSelected();
            });    
            
            var views = [APP_INFO_VIEW_ID, MY_MOBILE_VIEW_ID, APP_CATALOG_VIEW_ID, IN_PROGRESS_VIEW_ID];
            
            arr.forEach(views, function(view){            	            
            	connect.connect(registry.byId(view), "onAfterTransitionIn", function() {                	
                	_this._assesMoveBackRequired(view);
                	_this.refreshLayout();
                });            	            	            	
            }, this);
            
            // add all other views to main views list.
            views = views.concat([TEXT_DETAILS_VIEW_ID, SWITCH_VIEW_ID, FEEDBACK_VIEW_ID]);
            
            // Workaround for Heading label size/position issue.
            // Before onBeforeTransitionIn event, the view that will be displayed was hidden and thus has no size.
            // Now that the view is displayed it has a size.
            // It need to resize its children, especially the heading, in order to have a correct display.  
            arr.forEach(views, function(view){
            	var w = registry.byId(view);            	
            	connect.connect(w, "onBeforeTransitionIn", function() {            		
                	w.resize();                	
                });            	            	            	            
            }, this);
                                              
            for(var i=1; i < 5; i++){
	        	connect.connect(registry.byId(REFRESH_BUTTON_ID+i), "onClick", function() {
	        		 _this.notifyConnectionFailure = true;
	        		 _this.reload(false, true);	
	        	});
        	}
            for(var i=1; i < 4; i++){
	        	connect.connect(registry.byId(LEFT_REFRESH_BUTTON_ID+i), "onClick", function() {
	        	 _this.notifyConnectionFailure = true;	
        		 _this.reload(false, true);	
        		});
        	}
        	
        	installerSettings.init(this._username, '', this._serverURL, this._contextRoot, function(pUser, pPassword, pURL, pContextRoot) {
        	    _this.onNewSettings(pUser, pPassword, pURL, pContextRoot);
        	}, _this.bundle);
        	
        	settingsTab._onClick({ });
                    
            // To fix issues with scrollable view
            setTimeout(function () {
            	_this.refreshLayout();
            }, 3000);    
        };
        
        MeapInstaller.prototype._initializei18n = function() {
        
        	// set html element's text

        	registry.byId("appInfoPackage").set('label', this.bundle.appInfoPackageText);
        	registry.byId("appInfoPackageNav").set('label', this.bundle.appInfoPackageNavText);
        	registry.byId("appInfoVersion").set('label', this.bundle.appInfoVersionText);
        	registry.byId("appInfoDescription").set('label', this.bundle.appInfoDescriptionText);
        	registry.byId("appInfoDescriptionNav").set('label', this.bundle.appInfoDescriptionNavText);
        	registry.byId("appInfoMandatory").set('label', this.bundle.appInfoMandatoryText);
        	registry.byId("appInfoRating").set('label', this.bundle.appInfoRatingText);
    
        	registry.byId("myMobileViewHeader").set("label", this.bundle.myMobileViewHeaderText);
        	registry.byId("catalogViewHeader").set("label", this.bundle.catalogViewHeaderText);
            registry.byId("inProgressViewHeader").set("label", this.bundle.inProgressViewHeaderText);
        	
        	html.byId("nothingToProgressListItem").innerHTML = this.bundle.nothingToProgressListItemLabel;
        	html.byId("nothingInstalledListItem").innerHTML = this.bundle.myMobileViewMsg1;        	
        	//html.byId("headingTitleSpan").innerHTML = this.bundle.headingTitleSpanText;
        	html.byId("myMobileViewMsg2").innerHTML = this.bundle.myMobileViewMsg2; 
        	html.byId("offlineUpdateListItemText").innerHTML = this.bundle.myMobileViewMsg3; 
        	html.byId("catalogViewMsg1").innerHTML = this.bundle.catalogViewMsg1; 
        	html.byId("offlineCatalogListItemText").innerHTML = this.bundle.catalogViewMsg2; 
        	//html.byId("appInfoHeadingText").innerHTML = this.bundle.appInfoViewHeaderText; 
        	html.byId("progressInfoStatusCategoryText").innerHTML = this.bundle.progressInfoStatusCategoryText; 
        	html.byId("progressInfoStatus").innerHTML = this.bundle.progressInfoStatusText; 
        	//html.byId("textDetailsHeadingText").innerHTML = this.bundle.textDetailsViewHeaderText; 
        	html.byId("textDetailsCategoryText").innerHTML = this.bundle.textDetailsCategoryText; 
        	html.byId("textDetailsText").innerHTML = this.bundle.textDetailsText; 
        	registry.byId("versionSwitcherHeadingWidget").set("label", this.bundle.versionSwitcherViewHeaderText);        	
        	html.byId("versionSwitcherInstalledVersionCategoryText").innerHTML = this.bundle.versionSwitcherCategory1Text; 
        	html.byId("versionSwitcherAvailableVersionsCategoryText").innerHTML = this.bundle.versionSwitcherCategory2Text; 
            registry.byId("feedbackDetailsHeadingWidget").set("label", this.bundle.feedbackDetailsViewHeaderText);
        	html.byId("feedbackDetailsViewLabel1").innerHTML = this.bundle.feedbackDetailsViewLabel1;
        	html.byId("userIdSpan").innerHTML = this.bundle.userIdText;
        	html.byId("passwordSpan").innerHTML = this.bundle.passwordText; 
        	html.byId("serverUrlSpan").innerHTML = this.bundle.serverUrlText; 
        	html.byId("sslSpan").innerHTML = this.bundle.sslText; 
        	
        	registry.byId("noAppContentHeading").set("label", this.bundle.noAppContentViewHeaderText);  
        	html.byId("noAppContentViewMsg1").innerHTML = this.bundle.noAppContentViewMsg1; //this is a RoundRect in a <div> 

        	// seems that dojo does not i18nize some widget's attribute: then do it by hand        	
        	registry.byId("feedbackDetailsTextArea").set("placeHolder" , this.bundle.feedbackDetailsTextAreaPlaceHolderText); //this is a placeHolder attribute
        	registry.byId("settingsUserid").set("placeHolder" , this.bundle.settingsUseridPlaceHolderText); //this is a placeHolder attribute
        	registry.byId("settingsPassword").set("placeHolder" , this.bundle.settingsPasswordPlaceHolder); //this is a placeHolder attribute
        	registry.byId("settingsServerurl").set("placeHolder" , this.bundle.settingsServerurlPlaceHolderText); //this is a placeHolder attribute
        	
        };        
    });
    require([
           	"dojo/_base/declare",
           	"dojo/_base/sniff",
           	"dojox/mobile/ScrollableView"
           	], function(declare, has, ScrollableView){
           		return declare("com.ibm.mobile.appcenter.ScrollableView", ScrollableView, {
           			constructor: function(){
           			},
           			init: function(/*Object?*/params){
           				if(has('android') < 4){
           					this.scrollType = 2;
           				}
           				this.inherited(arguments);
           			}
           	});
       });
